VERSION 5.00
Begin VB.Form frmWaitTest 
   AutoRedraw      =   -1  'True
   Caption         =   "Watch Directory For Changes"
   ClientHeight    =   3315
   ClientLeft      =   3210
   ClientTop       =   1530
   ClientWidth     =   7200
   Icon            =   "frmWaitTest.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   221
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   480
   Begin VB.TextBox txChanges 
      Height          =   2100
      Left            =   2175
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   1110
      Width           =   4905
   End
   Begin VB.CommandButton cmdSelectDir 
      Caption         =   "Select Directory To Watch..."
      Height          =   495
      Left            =   3855
      TabIndex        =   3
      Top             =   465
      Width           =   3225
   End
   Begin VB.CommandButton cmdStopWatch 
      Caption         =   "Stop Watching Dir"
      Enabled         =   0   'False
      Height          =   495
      Left            =   165
      TabIndex        =   1
      Top             =   1680
      Width           =   1830
   End
   Begin VB.CommandButton cmdStartWatch 
      Caption         =   "Start Watching Dir"
      Height          =   495
      Left            =   165
      TabIndex        =   0
      Top             =   1110
      Width           =   1830
   End
   Begin VB.Label lblWatchPath 
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   165
      TabIndex        =   2
      Top             =   105
      Width           =   6900
   End
End
Attribute VB_Name = "frmWaitTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to use the FindFirstChangeNotification and
  ' FindNextChangeNotification API functions to watch directories for
  ' changes.  by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without warranty or
  ' guaranty of any kind.  In other words, use at your own risk.
  '
  '
  ' NOTE:  there are other routines that can detect changes in a directory.
  ' structure, most notably registering a change notification routine using
  ' the SHChangeNotifyRegister API function.  However, unless the application
  ' making changes to the file system is sending the proper notifications via
  ' the SHChangeNotify API function, only a minimal amount of information is
  ' returned.


  ' the directory we are watching
  Private m_sWatchedDir As String
  
  Private m_udtFT As FILETIME
  
  ' array to track files in the watched directory
  Private m_audtDirContents() As WIN32_FIND_DATA
  
  ' instance of the watch object
  Private WithEvents m_oWatchDir As cWatchForChanges
Attribute m_oWatchDir.VB_VarHelpID = -1

Private Sub m_oWatchDir_ChangeDetected(ByVal eChangeType As NOTIFY_CHANGE_TYPE)
  ' event fired from the watch object when a change is detected
  
  
  Dim sRet$, OutFT As FILETIME
  
  ' determine the type of change that occured....
  Select Case True
    Case (eChangeType And cwdName) > 0, (eChangeType And cwdDirName) > 0
      ' name change, we need to check the names in the dir against the
      ' info we cached when we started the watch
      
      sRet = FindFilesByName(m_sWatchedDir, eChangeType)
  
      ' reset the array since there was a name change....
      If LenB(sRet) Then
        FillFilesArray m_sWatchedDir
      Else
        If ((eChangeType And cwdSize) > 0) Or ((eChangeType And cwdLastWrite) > 0) Then
          sRet = FindFilesByTime(m_sWatchedDir, m_udtFT, OutFT, eChangeType)
        End If
        
        If LenB(sRet) = 0 Then
          sRet = ReturnChangeTypeString(eChangeType)
          
          If LenB(sRet) Then sRet = sRet & " changed but unable to detect changed file(s).  The change may have already been detected in the last notification."
        End If
      End If

  
    Case (eChangeType And cwdSize) > 0, (eChangeType And cwdLastWrite) > 0
      ' size or last write change, we only need to compare file times to see
      ' which file was changed.
      sRet = FindFilesByTime(m_sWatchedDir, m_udtFT, OutFT, eChangeType)
  
      If LenB(sRet) = 0 Then
        sRet = ReturnChangeTypeString(eChangeType)
        
        If LenB(sRet) Then sRet = sRet & " changed but unable to detect changed file(s).  The change may have already been detected in the last notification."
      End If
      
  End Select
  
  
  
  ' prepare the output string
  With txChanges
    .Text = .Text & "Change Logged At: " & Format$(Now, "hh:mm:ss") & vbNewLine
    
  
    If LenB(sRet) = 0 Then sRet = "Unable to finde changed file." & vbNewLine
    
    .Text = .Text & sRet & vbNewLine
    
    .SelStart = Len(.Text)
    
    Beep
  End With
  
  ' update the cached "lastwrite" time
  If CompareFileTime(OutFT, m_udtFT) = 1& Then m_udtFT = OutFT
  
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' always make sure the watch object is destroyed before exiting
  Set m_oWatchDir = Nothing
  
  ' clean up the array
  Erase m_audtDirContents
End Sub

Private Sub cmdSelectDir_Click()
  ' select a directory tree to watch
  m_sWatchedDir = MSupport.GetFolder(hWnd, "Select A Directory To Watch.")
  
  If FileExists(m_sWatchedDir) Then
    lblWatchPath.Caption = MSupport.DrawPathEllipsis(m_sWatchedDir, lblWatchPath, Me)
  End If
  
End Sub

Private Sub cmdStartWatch_Click()

  If FileExists(m_sWatchedDir) Then
    
    ' get the baseline for the files in the dir
    Call FillFilesArray(m_sWatchedDir)
    
    ' get the current time so that we have something to compare files with later on
    GetSystemTimeAsFileTime m_udtFT
    
    ' create a new instance of the watch object
    Set m_oWatchDir = New cWatchForChanges
    
    If m_oWatchDir.StartWatch(m_sWatchedDir) Then
      cmdStartWatch.Enabled = False
      cmdStopWatch.Enabled = True
      cmdSelectDir.Enabled = False
    Else
      MsgBox "An error occured.  Unable to watch directory."
    End If
  Else
    MsgBox "Invalid watch directory."
  End If
  
End Sub

Private Sub cmdStopWatch_Click()

  m_oWatchDir.StopWatch
  
  Set m_oWatchDir = Nothing

  cmdStartWatch.Enabled = True
  cmdStopWatch.Enabled = False
  cmdSelectDir.Enabled = True

End Sub

Private Function FindFilesByName(ByVal sPath$, ByVal eChangeType As NOTIFY_CHANGE_TYPE) As String
  ' finds files with changed names by checking the file names against the cached
  ' values in the module level array

  Dim i&, hFileSearch&, sFileNames$, nUbound&, sChangeType$, bFound As Boolean
  Dim udtFindData As WIN32_FIND_DATA, anFoundIndexes() As Boolean
  
  sChangeType = ReturnChangeTypeString(eChangeType)
  
  ' fix up the path
  If Right$(sPath, 1) <> "\" Then sPath = sPath & "\"

  ' start the search for all files in the folder
  hFileSearch = FindFirstFile(sPath & "*.*", udtFindData)

  If hFileSearch <> INVALID_HANDLE_VALUE Then
    
    If LenB(m_audtDirContents(0).cFileName) Then
      nUbound = UBound(m_audtDirContents)
    Else
      nUbound = (-1)
    End If
    
    ReDim anFoundIndexes(nUbound) As Boolean
    
    Do
      ' reset the variable
      bFound = False
      
      With udtFindData
        .cFileName = StripNulls(.cFileName)
        
        For i = 0 To nUbound
          If LenB(.cFileName) = LenB(m_audtDirContents(i).cFileName) Then
            ' only compare the strings if the length is the same
            If .cFileName = m_audtDirContents(i).cFileName Then
              bFound = True
              anFoundIndexes(i) = True
              Exit For
            End If
          End If
        Next
      
        If bFound = False Then
          sFileNames = sFileNames & "Change Type: " & sChangeType & vbNewLine
          
          If .dwFileAttributes And vbDirectory Then
            sFileNames = sFileNames & "  " & sPath & Trim$(.cFileName) & "  [Dir]" & vbNewLine
          Else
            sFileNames = sFileNames & "  " & sPath & Trim$(.cFileName) & vbNewLine
          End If
        End If
      End With
            
      If FindNextFile(hFileSearch, udtFindData) = API_FALSE Then
        ' if we get ERROR_NO_MORE_FILES close the search and jump out of the loop
        If Err.LastDllError = ERROR_NO_MORE_FILES Then
          Call FindClose(hFileSearch)
          Exit Do
        End If
      End If
    Loop
    
    For i = 0 To nUbound
      If anFoundIndexes(i) = False Then
        With m_audtDirContents(i)
          sFileNames = sFileNames & "Change Type: " & sChangeType & vbNewLine
          
          If .dwFileAttributes And vbDirectory Then
            sFileNames = sFileNames & "  " & sPath & Trim$(.cFileName) & "  [Deleted]" & " [Dir]" & vbNewLine
          Else
            sFileNames = sFileNames & "  " & sPath & Trim$(.cFileName) & "  [Deleted]" & vbNewLine
          End If
        End With
      End If
    Next
    
    FindFilesByName = sFileNames
    
  End If
  
End Function

Private Function FindFilesByTime(ByVal sPath$, InFT As FILETIME, OutFT As FILETIME, ByVal eChangeType As NOTIFY_CHANGE_TYPE) As String
  ' finds files by comparing the last write time with the cached value

  Dim udtFindData As WIN32_FIND_DATA, hFileSearch&, sFileNames$, sChangeType$
  
  sChangeType = ReturnChangeTypeString(eChangeType)
  
      
  ' fix up the path
  If Right$(sPath, 1) <> "\" Then sPath = sPath & "\"

  ' start the search for all files in the folder
  hFileSearch = FindFirstFile(sPath & "*.*", udtFindData)

  If hFileSearch <> INVALID_HANDLE_VALUE Then
    '
    Do
      With udtFindData
        If CompareFileTime(.ftLastWriteTime, InFT) = 1& Then
          sFileNames = sFileNames & "Change Type: " & sChangeType & vbNewLine
          
          sFileNames = sFileNames & "  " & sPath & StripNulls(.cFileName) & vbNewLine
          
          If CompareFileTime(.ftLastWriteTime, OutFT) = 1& Then
            OutFT.dwHighDateTime = .ftLastWriteTime.dwHighDateTime
            OutFT.dwLowDateTime = .ftLastWriteTime.dwLowDateTime
          End If
        ElseIf CompareFileTime(.ftCreationTime, InFT) = 1& Then
          sFileNames = sFileNames & "Change Type: " & sChangeType & vbNewLine
          
          sFileNames = sFileNames & "  " & sPath & StripNulls(.cFileName) & vbNewLine

          If CompareFileTime(.ftCreationTime, OutFT) = 1& Then
            OutFT.dwHighDateTime = .ftCreationTime.dwHighDateTime
            OutFT.dwLowDateTime = .ftCreationTime.dwLowDateTime
          End If
        End If
      End With
            
      If FindNextFile(hFileSearch, udtFindData) = API_FALSE Then
        ' if we get ERROR_NO_MORE_FILES close the search and jump out of the loop
        If Err.LastDllError = ERROR_NO_MORE_FILES Then
          Call FindClose(hFileSearch)
          Exit Do
        End If
      End If
    Loop
    
    FindFilesByTime = sFileNames
    
  End If
  
End Function

Private Sub FillFilesArray(ByVal sPath$) 'As FILETIME
  ' fills the module level array that caches all of the info on each file in the dir
  
  Dim i&, nUbound&, hFileSearch&, sFileNames$
  Dim udtFindData As WIN32_FIND_DATA
  
  Erase m_audtDirContents
  
  nUbound = 100
  
  ReDim m_audtDirContents(nUbound) As WIN32_FIND_DATA
  
  ' fix up the path
  If Right$(sPath, 1) <> "\" Then sPath = sPath & "\"

  ' start the search for all files in the folder
  hFileSearch = FindFirstFile(sPath & "*.*", udtFindData)

  If hFileSearch <> INVALID_HANDLE_VALUE Then
    '
    Do
      If i > nUbound Then
        nUbound = nUbound + 100
        
        ReDim Preserve m_audtDirContents(nUbound) As WIN32_FIND_DATA
      End If
      
      With udtFindData
        .cFileName = StripNulls(.cFileName)
      End With
      
      ' save the struct to the array
      m_audtDirContents(i) = udtFindData
            
      If FindNextFile(hFileSearch, udtFindData) = API_FALSE Then
        ' if we get ERROR_NO_MORE_FILES close the search and jump out of the loop
        If Err.LastDllError = ERROR_NO_MORE_FILES Then
          Call FindClose(hFileSearch)
          Exit Do
        End If
      End If
      
      i = i + 1
    Loop
  End If
  
  ReDim Preserve m_audtDirContents(i) As WIN32_FIND_DATA
  
End Sub

Private Function ReturnChangeTypeString(ByVal eChangeType As NOTIFY_CHANGE_TYPE) As String

  If (eChangeType And cwdName) > 0 Then ReturnChangeTypeString = "Name"
  
  If (eChangeType And cwdSize) > 0 Then
    If LenB(ReturnChangeTypeString) Then
      ReturnChangeTypeString = ReturnChangeTypeString & " & Size"
    Else
      ReturnChangeTypeString = "Size"
    End If
  End If
  
  If (eChangeType And cwdLastWrite) > 0 Then
    If LenB(ReturnChangeTypeString) Then
      ReturnChangeTypeString = ReturnChangeTypeString & " & Last Write"
    Else
      ReturnChangeTypeString = "Last Write"
    End If
  End If
  
  If (eChangeType And cwdDirName) > 0 Then
    If LenB(ReturnChangeTypeString) Then
      ReturnChangeTypeString = ReturnChangeTypeString & " & Dir Name"
    Else
      ReturnChangeTypeString = "Dir Name"
    End If
  End If
    
End Function

